import javax.swing.*;
import java.awt.BorderLayout;

/**
 * Set up the window and show four buttons and a label.
 * The size of the window is determined from the size of the label.
 * Three of the four buttons are given a "listener", an instance of the new class ButtonHandler.
 * The "west" button doesn't do anything, because it doesn't have a listener.
 * @version 10, 2 Feb 2005.
 **/
public class SetUpOperation implements Runnable
{
    public void run () {
        // Make sure we have nice window decorations.
        JFrame.setDefaultLookAndFeelDecorated(true);
        
        // Create the window and set its size.
        JFrame frame = new JFrame ("My example program");
        
        // Make sure the program exits when the window is closed.
        frame.setDefaultCloseOperation (JFrame.EXIT_ON_CLOSE);
        
        // Add something to the window.
        JButton northButton = new JButton ("north");
        JButton southButton = new JButton ("south");
        JButton eastButton = new JButton ("east");
        JButton westButton = new JButton ("west");
        JLabel centerText = new JLabel ("some text in the center");
        frame.getContentPane().add(northButton, BorderLayout.NORTH);
        frame.getContentPane().add(centerText, BorderLayout.CENTER);
        frame.getContentPane().add(eastButton, BorderLayout.EAST);
        frame.getContentPane().add(southButton, BorderLayout.SOUTH);
        frame.getContentPane().add(westButton, BorderLayout.WEST);
        
        ButtonHandler handler = new ButtonHandler (centerText);
        northButton.addActionListener (handler);
        southButton.addActionListener (handler);
        eastButton.addActionListener (handler);
        // Let's leave westButton without a listener for now.
        
        // Compute the size of the window, just big enough to hold the labels.
        frame.pack();
        
        // Show the window.
        frame.setVisible(true);
    }
}